﻿using TxF;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Transactions;

namespace TxF.Test
{
    
    
    /// <summary>
    ///This is a test class for DirectoryTest and is intended
    ///to contain all DirectoryTest Unit Tests
    ///</summary>
    [TestClass()]
    public class DirectoryTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for CreateDirectory
        ///</summary>
        [TestMethod()]
        public void CreateDirectoryTest()
        {
            using (System.Transactions.TransactionScope ts = new System.Transactions.TransactionScope())
            {
                string path = "c:\\tmp\\TestFolder";
                Directory.CreateDirectory(path, true);
                ts.Complete();
            }

            using (TxF.Transaction t = new TxF.Transaction())
            {
                string path = "c:\\tmp\\TestFolder2";
                Directory.CreateDirectory(path, false, t);
                t.Commit();
            }
        }

        /// <summary>
        ///A test for Delete
        ///</summary>
        [TestMethod()]
        public void DeleteTest()
        {
            using (System.Transactions.TransactionScope ts = new System.Transactions.TransactionScope())
            {
                string path = "c:\\tmp\\TestFolder";
                Directory.Delete(path, false);
                ts.Complete();
            }
            
        }

        /// <summary>
        ///A test for CreateSymbolicLink
        ///</summary>
        [TestMethod()]
        public void CreateSymbolicLinkTest()
        {
            using (System.Transactions.TransactionScope ts = new System.Transactions.TransactionScope())
            {
                string pathSymbolicLinkDirectory = @"c:\tmp\TestFiles_SL";
                string pathDirector = @"c:\Progetti\WIN\System.IO.Transactions.TxF\TestFiles\";
                Directory.CreateSymbolicLink(pathSymbolicLinkDirectory, pathDirector);
                ts.Complete();
            }
        }

        /// <summary>
        ///A test for GetDirectory
        ///</summary>
        [TestMethod()]
        public void GetDirectoryTest()
        {
            using (System.Transactions.TransactionScope ts = new System.Transactions.TransactionScope())
            {
                string pathDirectory = @"c:\tmp\";
                Directory actual;
                actual = Directory.GetDirectory(pathDirectory);
                
            }
        }
    }
}
